#include <iostream>
#include "dynfilefmtio.h"
#include "stringmaniplib.h"
#include "memoryblock.h"
using namespace std;

string stripCtrlChars(string s)
{
    string ss = s;
    unsigned int i;
    for (i = 0; i < ss.size(); i++)
    {
        if (ss[i] < 32)
        {
            ss[i] = '.';
        }
    }
    return ss;
}

bool isNumber(string s)
{
    if (s == (string)"") { return false; }
    if (! ( ((s[0] == '-') && (s.size() > 1)) || ((s[0] >= '0') && (s[0] <= '9')) ) ) { return false; }
    if (s.size() < 2) { return true; }
    unsigned int i;
    for (i = 1; i < s.size(); i++)
    {
        if ( (s[i] < '0') || (s[i] > '9') ) { return false; }
    }
    return true;
}

bool isNumber(char * s)
{
    string ss = s;
    return isNumber(ss);
}

void toc(dynfilefmtio & d)
{
    unsigned long int i, j, m, n;
    int cid;
    string csymb;
    unsigned long int cidx;
    string cname;
    string cids;
    unsigned short int cflag;
    string cflags;
    memoryblock mb;
    string ddd;
    m = d.numSymbols();
    if (m>0)
    {
        for (i=1; i<=m; i++)
        {
            csymb = d.nthSymbol(i);
            n = d.numNumbers(csymb);
            for (j=1; j<=n; j++)
            {
                cid = d.nthNumber(csymb, j);
                cidx = d.getRecordIndex(csymb, cid);
                cname = d.getRecordNameByIndex(cidx);
                cflag = d.getRecordFlagsByIndex(cidx);
                mb = d.getRecordDataByIndex(cidx);
                //cname = d.getRecordName(csymb, cid);
                //cflag = d.getRecordFlags(csymb, cid);
                //mb = d.getRecordData(csymb, cid);
                
                cids = str(cid);
                cids = right((string)"      "+cids,6);
                cname = left(cname + (string)"                        ",22);
                cflags = dffFlagBitsToUserString(cflag);
                ddd = mb.getStringValueAsString(0,20);
                if (mb.getSize() < 20) { ddd = left(ddd, mb.getSize()); }
                ddd = stripCtrlChars(ddd);
                cout << csymb << "  " << cids << "  " << cname << "  " << cflags << "  " << ddd << endl;
            }
        }
    }
}

int main (int argc, const char * argv[])
{
    if ( argc < 3 )
    {
        cout << "Usage: dff <filename> <command> <parameter1> <parameter2> ..." << endl;
        return 0;
    }
    dynfilefmtio d;
    string filename = argv[1];
    string filename2;
    string cmd = argv[2];
    string cmd2;
    string arg;
    string arg2;
    string newvalue;
    string asymb, aid, atitle, aflags, adt;
    memoryblock m;
    binarystream b;
    dffrecord r;
    int l, mode;
    if ( cie(cmd, (string)"create") )
    {
        d.create(filename);
    } else {
        d.open(filename);
    }
    if ( cie(cmd, (string)"toc") )
    {
        toc(d);
    }
    else if ( cie(cmd, (string)"count-symbols") )
    {
        cout << d.numSymbols() << endl;
    }
    else if ( cie(cmd, (string)"symbol") )
    {
        if ( argc < 4 ) { cout << "Invalid parameter count." << endl; return 0; }
        arg = argv[3];
        cout << d.nthSymbol(atoi(arg.c_str())) << endl;
    }
    else if ( cie(cmd, (string)"count-ids") )
    {
        if ( argc < 4 ) { cout << "Invalid parameter count." << endl; return 0; }
        arg = argv[3];
        arg = left(arg + (string)"        ", 8);
        cout << d.numNumbers(arg) << endl;
    }
    else if ( cie(cmd, (string)"id") )
    {
        if ( argc < 5 ) { cout << "Invalid parameter count." << endl; return 0; }
        arg = argv[3];
        arg = left(arg + (string)"        ", 8);
        arg2 = argv[4];
        cout << d.nthNumber(arg, atoi(arg2.c_str())) << endl;
    }
    else if ( cie(cmd, (string)"next-available") )
    {
        if ( argc < 4 ) { cout << "Invalid parameter count." << endl; return 0; }
        arg = argv[3];
        arg = left(arg + (string)"        ", 8);
        cout << d.nextAvailableNumber(arg) << endl;
    }
    else if ( cie(cmd, (string)"count-items") )
    {
        cout << (d.maxIndexValue()+1) << endl;
    }
    else if ( cie(cmd, (string)"add") )
    {
        if ( argc < 9 ) { cout << "Invalid parameter count." << endl; return 0; }
        asymb = argv[3];
        aid = argv[4];
        atitle = argv[5];
        aflags = argv[6];
        adt = argv[7];
        newvalue = argv[8];
        m.setSize(newvalue.size());
        m.setStringValueAsString(0, newvalue.size(), newvalue);
        r.datatype = atoi(adt.c_str());
        r.setflagint(atoi(aflags.c_str()));
        r.idnumber = atoi(aid.c_str());
        r.symbol = asymb;
        r.title = atitle;
        r.thedata = m;
        r.readindatalen = m.getSize();
        d.addRecord(r);
    }
    else if ( cie(cmd, (string)"add-file") )
    {
        if ( argc < 9 ) { cout << "Invalid parameter count." << endl; return 0; }
        asymb = argv[3];
        aid = argv[4];
        atitle = argv[5];
        aflags = argv[6];
        adt = argv[7];
        filename2 = argv[8];
        
        b.open(filename2, false, false);
        l = b.getLength();
        m.setSize(l);
        if (l > 0)
        {
            char * ch;
            ch = b.read(l);
            m.setStringValue(0, l, ch);
            delete [] ch;
        }
        b.close();
        
        r.datatype = atoi(adt.c_str());
        r.setflagint(atoi(aflags.c_str()));
        r.idnumber = atoi(aid.c_str());
        r.symbol = asymb;
        r.title = atitle;
        r.thedata = m;
        r.readindatalen = m.getSize();
        d.addRecord(r);
    }
    else if ( cie(cmd, (string)"delete-all") )
    {
        d.deleteAllRecords();
    }
    else if ( cie(cmd, (string)"delete") )
    {
        if ( argc < 4 ) { cout << "Invalid parameter count." << endl; return 0; }
        arg = argv[3];
        if (isNumber(arg))
        {
            d.deleteRecordByIndex(atoi(arg.c_str()));
        }
        else
        {
            if ( argc < 5 ) { cout << "Invalid parameter count." << endl; return 0; }
            arg = left(arg + (string)"        ", 8);
            arg2 = argv[4];
            if (isNumber(arg2))
            {
                d.deleteRecord(arg, atoi(arg2.c_str()));
            }
            else
            {
                d.deleteRecordByName(arg, arg2);
            }
        }
    }
    else if ( cie(cmd, (string)"get") )
    {
        if ( argc < 5 ) { cout << "Invalid parameter count." << endl; return 0; }
        cmd2 = argv[3];
        arg = argv[4];
        if (isNumber(arg))
        {
            mode = 0;
        } else {
            if ( argc < 6 ) { cout << "Invalid parameter count." << endl; return 0; }
            arg = left(arg + (string)"        ", 8);
            arg2 = argv[5];
            if (isNumber(arg2)) { mode = 1; } else { mode = 2; }
        }
        if ( cie(cmd2, (string)"info"))
        {
            if ( mode == 0 ) { r = d.getRecordByIndex(atoi(arg.c_str())); }
            if ( mode == 1 ) { r = d.getRecord(arg,atoi(arg2.c_str())); }
            if ( mode == 2 ) { r = d.getRecordByName(arg,arg2); }
            cout << "   Symbol: " << r.symbol << endl;
            cout << "       ID: " << r.idnumber << endl;
            cout << "     Name: " << r.title << endl;
            cout << "    Flags: " << dffFlagBitsToUserString(r.getflagint()) << endl;
            cout << "Data Type: " << r.datatype << endl;
            cout << "   Length: " << r.thedata.getSize() << endl;
        }
        else if ( cie(cmd2, (string)"data"))
        {
            if ( mode == 0 ) { m = d.getRecordDataByIndex(atoi(arg.c_str())); }
            if ( mode == 1 ) { m = d.getRecordData(arg,atoi(arg2.c_str())); }
            if ( mode == 2 ) { m = d.getRecordDataByName(arg,arg2); }
            cout << m.getStringValueAsString(0, m.getSize()) << endl;
        }
        else if ( cie(cmd2, (string)"datatype"))
        {
            if ( mode == 0 ) { cout << d.getRecordDataTypeByIndex(atoi(arg.c_str())) << endl; }
            if ( mode == 1 ) { cout << d.getRecordDataType(arg,atoi(arg2.c_str())) << endl; }
            if ( mode == 2 ) { cout << d.getRecordDataTypeByName(arg,arg2) << endl; }
        }
        else if ( cie(cmd2, (string)"length"))
        {
            if ( mode == 0 ) { cout << d.getRecordLengthByIndex(atoi(arg.c_str())) << endl; }
            if ( mode == 1 ) { cout << d.getRecordLength(arg,atoi(arg2.c_str())) << endl; }
            if ( mode == 2 ) { cout << d.getRecordLengthByName(arg,arg2) << endl; }
        }
        else if ( cie(cmd2, (string)"flags"))
        {
            if ( mode == 0 ) { cout << d.getRecordFlagsByIndex(atoi(arg.c_str())) << endl; }
            if ( mode == 1 ) { cout << d.getRecordFlags(arg,atoi(arg2.c_str())) << endl; }
            if ( mode == 2 ) { cout << d.getRecordFlagsByName(arg,arg2) << endl; }
        }
        else if ( cie(cmd2, (string)"name"))
        {
            if ( mode == 0 ) { cout << d.getRecordNameByIndex(atoi(arg.c_str())) << endl; }
            if ( mode == 1 ) { cout << d.getRecordName(arg,atoi(arg2.c_str())) << endl; }
            if ( mode == 2 ) { cout << d.getRecordNameByName(arg,arg2) << endl; }
        }
        else if ( cie(cmd2, (string)"id"))
        {
            if ( mode == 0 ) { cout << d.getRecordNumberByIndex(atoi(arg.c_str())) << endl; }
            if ( mode == 1 ) { cout << d.getRecordNumber(arg,atoi(arg2.c_str())) << endl; }
            if ( mode == 2 ) { cout << d.getRecordNumberByName(arg,arg2) << endl; }
        }
        else if ( cie(cmd2, (string)"symbol"))
        {
            if ( mode == 0 ) { cout << d.getRecordSymbolByIndex(atoi(arg.c_str())) << endl; }
            if ( mode == 1 ) { cout << arg << endl; }
            if ( mode == 2 ) { cout << arg << endl; }
        }
        else if ( cie(cmd2, (string)"index"))
        {
            if ( mode == 0 ) { cout << arg << endl; }
            if ( mode == 1 ) { cout << d.getRecordIndex(arg,atoi(arg2.c_str())) << endl; }
            if ( mode == 2 ) { cout << d.getRecordIndexByName(arg,arg2) << endl; }
        }
    }
    else if ( cie(cmd, (string)"set") )
    {
        if ( argc < 6 ) { cout << "Invalid parameter count." << endl; return 0; }
        cmd2 = argv[3];
        arg = argv[4];
        if (isNumber(arg))
        {
            newvalue = argv[5];
            mode = 0;
        } else {
            if ( argc < 7 ) { cout << "Invalid parameter count." << endl; return 0; }
            arg = left(arg + (string)"        ", 8);
            arg2 = argv[5];
            newvalue = argv[6];
            if (isNumber(arg2)) { mode = 1; } else { mode = 2; }
        }
        if ( cie(cmd2, (string)"data"))
        {
            m.setSize(newvalue.size());
            m.setStringValueAsString(0, newvalue.size(), newvalue);
            if ( mode == 0 ) { d.setRecordDataByIndex(atoi(arg.c_str()),m); }
            if ( mode == 1 ) { d.setRecordData(arg,atoi(arg2.c_str()),m); }
            if ( mode == 2 ) { d.setRecordDataByName(arg,arg2,m); }
        }
        if ( cie(cmd2, (string)"datatype"))
        {
            if ( mode == 0 ) { d.setRecordDataTypeByIndex(atoi(arg.c_str()),atoi(newvalue.c_str())); }
            if ( mode == 1 ) { d.setRecordDataType(arg,atoi(arg2.c_str()),atoi(newvalue.c_str())); }
            if ( mode == 2 ) { d.setRecordDataTypeByName(arg,arg2,atoi(newvalue.c_str())); }
        }
        else if ( cie(cmd2, (string)"flags"))
        {
            if ( mode == 0 ) { d.setRecordFlagsByIndex(atoi(arg.c_str()),atoi(newvalue.c_str())); }
            if ( mode == 1 ) { d.setRecordFlags(arg,atoi(arg2.c_str()),atoi(newvalue.c_str())); }
            if ( mode == 2 ) { d.setRecordFlagsByName(arg,arg2,atoi(newvalue.c_str())); }
        }
        else if ( cie(cmd2, (string)"name"))
        {
            if ( mode == 0 ) { d.setRecordNameByIndex(atoi(arg.c_str()),newvalue); }
            if ( mode == 1 ) { d.setRecordName(arg,atoi(arg2.c_str()),newvalue); }
            if ( mode == 2 ) { d.setRecordNameByName(arg,arg2,newvalue); }
        }
        else if ( cie(cmd2, (string)"id"))
        {
            if ( mode == 0 ) { d.setRecordNumberByIndex(atoi(arg.c_str()),atoi(newvalue.c_str())); }
            if ( mode == 1 ) { d.setRecordNumber(arg,atoi(arg2.c_str()),atoi(newvalue.c_str())); }
            if ( mode == 2 ) { d.setRecordNumberByName(arg,arg2,atoi(newvalue.c_str())); }
        }
        else if ( cie(cmd2, (string)"symbol"))
        {
            if ( mode == 0 ) { d.setRecordSymbolByIndex(atoi(arg.c_str()),newvalue); }
            if ( mode == 1 ) { d.setRecordSymbol(arg,atoi(arg2.c_str()),newvalue); }
            if ( mode == 2 ) { d.setRecordSymbolByName(arg,arg2,newvalue); }
        }
    }
    else if ( cie(cmd, (string)"inject") )
    {
        if ( argc < 5 ) { cout << "Invalid parameter count." << endl; return 0; }
        arg = argv[3];
        if (isNumber(arg))
        {
            filename2 = argv[4];
        
            b.open(filename2, false, false);
            l = b.getLength();
            m.setSize(l);
            if (l > 0)
            {
                char * ch;
                ch = b.read(l);
                m.setStringValue(0, l, ch);
                delete [] ch;
            }
            b.close();
            
            d.setRecordDataByIndex(atoi(arg.c_str()),m);
        }
        else
        {
            if ( argc < 6 ) { cout << "Invalid parameter count." << endl; return 0; }
            arg = left(arg + (string)"        ", 8);
            arg2 = argv[4];
            filename2 = argv[5];
        
            b.open(filename2, false, false);
            l = b.getLength();
            m.setSize(l);
            if (l > 0)
            {
                char * ch;
                ch = b.read(l);
                m.setStringValue(0, l, ch);
                delete [] ch;
            }
            b.close();
            
            if (isNumber(arg2))
            {
                d.setRecordData(arg, atoi(arg2.c_str()), m);
            }
            else
            {
                d.setRecordDataByName(arg, arg2, m);
            }
        }
    }
    else if ( cie(cmd, (string)"extract") )
    {
        if ( argc < 5 ) { cout << "Invalid parameter count." << endl; return 0; }
        arg = argv[3];
        if (isNumber(arg))
        {
            filename2 = argv[4];
            m = d.getRecordDataByIndex(atoi(arg.c_str()));
        }
        else
        {
            if ( argc < 6 ) { cout << "Invalid parameter count." << endl; return 0; }
            arg = left(arg + (string)"        ", 8);
            arg2 = argv[4];
            filename2 = argv[5];
            if (isNumber(arg2))
            {
                m = d.getRecordData(arg, atoi(arg2.c_str()));
            }
            else
            {
                m = d.getRecordDataByName(arg, arg2);
            }
        }
        
        b.open(filename2, true, true);
        if (m.getSize() > 0)
        {
            char * ch;
            ch = m.getStringValue(0,m.getSize());
            b.write(ch, m.getSize());
            delete [] ch;
        }
        b.close();
    }
    d.close();
    return 0;
}
